/*
This software and ancillary information (herein called SOFTWARE )
called LinuxBIOS          is made available under the terms described
here.  The SOFTWARE has been approved for release with associated
LA-CC Number 00-34   .  Unless otherwise indicated, this SOFTWARE has
been authored by an employee or employees of the University of
California, operator of the Los Alamos National Laboratory under
Contract No. W-7405-ENG-36 with the U.S. Department of Energy.  The
U.S. Government has rights to use, reproduce, and distribute this
SOFTWARE.  The public may copy, distribute, prepare derivative works
and publicly display this SOFTWARE without charge, provided that this
Notice and any statement of authorship are reproduced on all copies.
Neither the Government nor the University makes any warranty, express 
or implied, or assumes any liability or responsibility for the use of
this SOFTWARE.  If SOFTWARE is modified to produce derivative works,
such modified SOFTWARE should be clearly marked, so as not to confuse
it with the version available from LANL.
 */
/* Copyright 2000, Ron Minnich, Advanced Computing Lab, LANL
 * rminnich@lanl.gov
 */

/* this sets up the intel 440 dram. */

/*	now the fun begins.
	turn on the dramand wait a while (this from the intel book)
	turn power on and set the nop bit too
 */
	CS_WRITE($0x76, $0x30)

/* delay 200 us*/
        mov $0x20000, %ecx
.loop:  loop .loop

/* First, set registers we can set once to reasonable values  */
/*; note -- this code auto-generated ...*/
/*; note -- we need to grab the nice macro from the other chipset file.*/
/*; set it for sdram, 31 microsecond refresh (? ok? )*/
/*; should we be doing this just yet? who knows?*/
/*; turn on the power and set refresh clock to 31 us*/
	CS_WRITE($0x57, $0x12)
/* for those registers that are 0 and default to 0 we're not going to */
/*; do the register set. We're seeing problems that may be timing, so the */
/*; less we poke at this thing the better. */
/*; WRONG. seems we need this?*/
	CS_WRITE($0x59, $0)

/*; bank size registers -- 20, then 20, then 40, then 40, 60, 60, 80, 80*/
/*; on our mboards. */
	CS_WRITE($0x60, $0x20)
	CS_WRITE($0x61, $0x20)
	CS_WRITE($0x62, $0x20)
	CS_WRITE($0x63, $0x20)
	CS_WRITE($0x64, $0x20)
	CS_WRITE($0x65, $0x20)
	CS_WRITE($0x66, $0x20)
	CS_WRITE($0x67, $0x20)
	
	CS_WRITE($0x69, $0x0)
	CS_WRITE($0x6a, $0x0)
	CS_WRITE($0x6b, $0x0)
	
	CS_WRITE($0x6c, $0x0)
	CS_WRITE($0x6d, $0x0)
	CS_WRITE($0x6e, $0x0)

	CS_WRITE($0x74, $0x22)
	CS_WRITE($0x75, $0x22)

	CS_WRITE($0x78, $0x7)
	CS_WRITE($0x79, $0x55)

#if 0	
/*; These regs read back as zero, but setting to zero is reserved (!)*/
/*; So I won't do anything for now and hope it improves things. */
/*; Based on the book, it seems they should be set to 'all 1', i.e.*/
/*; set for 100 mhz part. */
/*;	mov eax, 0x800000c8*/
/*;	out dx, eax*/
/*;	mov dx, 0xcfe*/
/*;	mov al, 0x0*/
/*;	out dx, al*/
/*;	mov dx, 0xcf8*/
/*;	mov eax, 0x800000c8*/
/*;	out dx, eax*/
/*;	mov dx, 0xcff*/
/*;	mov al, 0x0*/
/*;	out dx, al*/
#endif
	CS_WRITE($0xcc, $0x1e)
		
/*; standard init of sdram at this point:*/
/*; it is on and the bridge is configured for 256M dimms. */
/*; now we have to do a precharge all (see the pc100 sdram book*/
/* thank goodness we're in protected mode! */
	mov $0xcf8, %dx
	movl $0x80000074, %eax
	outl %eax, %dx
/*; now we stick to reg 76, so no more of that*/
	mov $0xcfe, %dx
#define PUT76(data) mov data, %al ;  outb %al, %dx
/* do the nop cycle -- this is a read*/
	mov 0x400, %eax
/*; now we have to kick the dram to do this? so what, I guess we hit it, */
/*; but we're not in bigreal, wonder what will happen. Just to bank 0 for*/
/*; now. A10 has to be high. (pc100 sdram book)*/
/*; this should be a Precharge all*/
	PUT76($0x50)
/* load from dram for the precharge */
	mov 0x400, %eax
/*; now we do the eight CBRs*/
	PUT76($0x90)
/*;        PORT_80 0xdf*/
	mov 0x400, %eax
	mov 0x400, %eax
	mov 0x400, %eax
	mov 0x400, %eax
	mov 0x400, %eax
	mov 0x400, %eax
	mov 0x400, %eax
	mov 0x400, %eax
/*; now a mode register set*/
	PUT76($0x70)
/*;        PORT_80 0xdf*/
/*; we have to do a memory reference that sets things up. */
/*; ok -- we go with burst length 4 (?) wrap type 0, ltmode 3*/
/*; ltmod 3 matches the other mode in the bridge. This is slow, */
/*; we fix later if possible*/
/*; now we reference the dram to issue the mrs*/
	movl 0x150, %eax
/*; well, maybe it is working now.*/
/*; delay a bit and go to normal mode*/
/*;        PORT_80 0xdf*/
	PUT76($0x17)
	

