/*
 * Bootstrap code for the intel
 * $Id: intel_chip.S,v 1.1 2000/06/02 17:00:42 rminnich Exp $
 *
 */

#include <rom/asm.h>
#include <rom/stpc.h>

#include "intel_conf.h"
 
 	.text
	.code16

/*
 * stpc_chip_init:
 */
GLOBAL(intel_chip_init)
#if 0
/* later dudes ...
	/* 
	 * Disable shadow 0xf000, since we already use
	 * the link register (%sp), we can't call the
	 * ``stpc_chip_write routine. 
	 */
#if 0
	xorb	%al, %al
	movb	$0x28, %ah
	stpc_conf_write_macro

	jmp	.Lflush			/* make sure now fetched from rom
					 * not shadow after soft reset */
#endif
	.balign	16
.Lflush:

	/*
	 * XXX
	 */
	movl	$EXT(stpc_chip_table), %si
.Lget:	xorb	%dh, %dh		/* clear %dh */

	/* get the port */
	movb	%cs:(%si), %dl
	cmpb	$0xff, %dl
	je	.Ldone
	
	/* add 1 to pointer */
	inc	%si

	/* get data and add 2 to pointer*/
#if 1
	movb	%cs:(%si), %ch		/* get mask */
	inc	%si
	movb	%cs:(%si), %cl		/* get data */
	inc	%si
#else
	movw	%cs:(%si), %cx		/* get mask/data */
	xchgb	%cl, %ch		/* swap */
#endif
	
	/* send index to index register */
	movw	%dx, %ax
	outb	%al, $STPC_CONF_REG_INDEX
	
	/* read data, mask and set */
	inb	$STPC_CONF_REG_DATA, %al
	andb	%ch, %al
	orb	%cl, %al
	movb	%al, %cl
	
	/* send data to register */
	movw	%dx, %ax
	outb	%al, $STPC_CONF_REG_INDEX
	movb	%cl, %al
	outb	%al, $STPC_CONF_REG_DATA

	/* loop back */
	jmp	.Lget
.Ldone:
	jmp	*%sp

/*
 * stpc_chip_refresh:
 */
GLOBAL(stpc_chip_refresh)
	/*
	 * First of all we get the bus speed
	 */
	stpc_chip_getbusspeed_macro

 	movl	$EXT(stpc_dram_refresh), %ebx
 	xorb	%ah, %ah
	addw	%ax, %bx
	movb	%cs:0(%bx), %al

	movb	$0x39, %ah	/* refresh control reg */
	stpc_conf_write_macro
	jmp	*%sp
	

/* 
 * stpc_chip_setmtype:
 *
 *	%bx	bank
 *	%dx	type
 */
GLOBAL(stpc_chip_setmtype)
	cmpw	$3, %bx
	ja	.L0err		/* just return */
	cmpb	$3, %dl
	ja	.L0err		/* just return */

	movw	%dx, %si	/* get timing table */
	shlw	$3, %si		/* 	si = 8 * bx */

	/** point to our timings */
	movl	$EXT(stpc_chip_timing_table), %edi
	addw	%si, %di

	/** get bus speed */
	stpc_chip_getbusspeed_macro
	xorb	%ah, %ah
	addw	%ax, %di
	
	/** get the timing */
	movb	%cs:(%di), %al

.L0settiming:
	/** timing are in %al */
	movl	$EXT(stpc_chip_bank_table), %esi
	addw	%bx, %si
	movb	%cs:(%si), %ah
	stpc_conf_write_macro

.L0settype:
	/** set type */
	movb	%dl, %al	/* get type */
	shrb	$1, %al		/*	al = dx >> 1 */
	movw	%bx, %cx
	cmpw	$0, %cx
	je	.L0write
.L0shlloop:
	shlb	$2, %al		/*	al = al << 1 */
	loop	.L0shlloop
.L0write:
	movb	%al, %cl
	movb	$0x37, %ah	/* Memory Type Register - C.I. 37 */
	stpc_conf_read_macro
	orb	%cl, %al
	stpc_conf_write_macro
	jmp	.L0ret
.L0err:	stc
.L0ret:	jmp	*%sp
 	
 	
STATIC(stpc_chip_timing_table)
	/* FPM 60ns */
	.byte	0x29, 0x29, 0x29, 0x29	/* 25, 33, 40, 50 MHz */
	.byte	0xba, 0xbe, 0xbe, 0x80	/* 60, 66, 75, 80 MHz */
 	
 	/* FPM 70ns */
 	.byte	0x29, 0x29, 0x39, 0x39
 	.byte	0xba, 0xbe, 0xbe, 0x80
 	
 	/* EDO 60ns */
 	.byte	0x29, 0x29, 0x29, 0x29
 	.byte	0x39, 0x3d, 0x3d, 0x3d

	/* EDO 70ns */
 	.byte	0x29, 0x29, 0x29, 0x39
 	.byte	0x39, 0x3d, 0x0d, 0x0d

STATIC(stpc_chip_bank_table)
	.byte	0x35, 0x38, 0x3a, 0x3b	/* registers */
	
/*
 * stpc_chip_table:
 *
 *	Data to initialize the chip. 
 */
STATIC(stpc_chip_table)
/*
 *	Shadow:
 */
	.byte	0x25, 0b00000000, 0b00000000	/* shadow disable for C000 seg */
	.byte	0x26, 0b00000000, 0b00000000	/* shadow disable for D000 seg */
	.byte	0x27, 0b00000000, 0b00000000	/* shadow disable for E000 seg */
	.byte	0x28, 0b00000000, 0b00000000	/* shadow disable for F000 seg */
	
/*
 *	Memory:
 */
	.byte	0x34, 0b00000000, 0b00000000	/* memory bank width */
	.byte	0x35, 0b00000000, 0b10000000	/* bank 0 timing : slowest + deactive RAS */
	.byte	0x38, 0b00000000, 0b10000000	/* bank 1 timing : slowest */
	.byte	0x3A, 0b00000000, 0b10000000	/* bank 2 timing : slowest */
	.byte	0x3B, 0b00000000, 0b10000000	/* bank 3 timing : slowest */
	.byte	0x37, 0b00000000, 0b00000000	/* type: FPM all banks */
	
/*
 *	ISA interface:
 */
 	.byte	0x59, 0b00000000, 0b00000000	/* ISA synchronizer on */
 	.byte	0x50, 0b00000000, 0b00000000	/* ISA 14MHz/2 no post, enable kbd, a20+reset */
 	.byte	0x56, 0b00000000, 0b00000000	/* irqs 0-7 are edge sensitive */
 	.byte	0x57, 0b00000000, 0b00000001	/* irqs 8-15 are edge sensitive */
 	.byte	0x01, 0b00000000, 0b11000000	/* 4clk wait state on ipc */

 /*
  *	Cache/CPU interface registers:
  */
 	.byte	0xC1, 0b11101111, 0b00000000	/* force lock */	
 	.byte	0xC2, 0b00000001, 0b11010010	/* CPU WB if + burst write, 
 						 * enable BARB disable WT rom */	

 	.byte	0x20, 0b00000000, 0b00100000
 	.byte	0x21, 0b00000000, 0b00000000	/* geeh? 2MB cache */
 	.byte	0x22, 0b00000000, 0b11111111	/* give the slowest CPU i/f */
 	.byte	0x24, 0b00000000, 0b00000000	/* no ISA mem hole */	
 
 /*
  * 	Graphic stuff:
  */
	.byte	0x29, 0b00000000, 0b00000100	/* VGA disable, PCI palette snoop */
	.byte	0x40, 0b00000000, 0x64		/* GCLK x2 PLL */
	.byte	0x41, 0b00000000, 0x5d		/*          --> 64 and 5d make 45MHz */ 

/*
 *	Power managment:
 */
	.byte	0x60, 0b00000000, 0b00000000
	.byte	0x61, 0b00000000, 0b00000000
	.byte	0x8d, 0b00000000, 0b00000000
	.byte	0x62, 0b00000000, 0b00000000
	.byte	0x63, 0b00000000, 0b00000000
	.byte	0x64, 0b00000000, 0b00000000
	.byte	0x65, 0b00000000, 0b00000000
	.byte	0x66, 0b00000000, 0b00000000
	.byte	0x67, 0b00000000, 0b00000000
	.byte	0x68, 0b00000000, 0b00000000
	.byte	0x69, 0b00000000, 0b00000000
	.byte	0x6a, 0b00000000, 0b00000000

/*
 *	SMI generation:
 */
	.byte	0x71, 0b00000000, 0b00000000	/* do not generate SMI */
	
	/* PMU: */
	.byte	0x7a, 0b00000000, 0b00000000	/* PMU test reg */
	.byte	0x7c, 0b00000000, 0b00000000	/* CPU clock trottle disable,
						 * Clock off enable */

/* 
 *	ROM chip select:			(ISA INTERFACE, page 13/17)
 */
	.byte	0x51, 0b00000000, 0b00001000	/* PROM write protected,
						 * segments E,D,C segment share off */

/*
 *	IPC:
 */
	.byte	0x01, 0b00000000, 0x0c		/* IPC */
	.byte	0xff				/* end of table */


/*
 *
 */
STATIC(stpc_dram_refresh)
	.byte	0x18, 0x20, 0x27, 0x30		/* 25, 33, 40, 50 MHz */
	.byte	0x3a, 0x41, 0x49, 0x4e		/* 60, 66, 75, 80 MHz */

#endif
