/*
 * $Id: intel_crt0.S,v 1.1 2000/06/02 17:00:42 rminnich Exp $
 *
 */

#include <rom/asm.h>
#include <rom/intel.h>

#include "intel_conf.h"

/*
 * This is the entry code (the mkrom(8) utility makes a jumpvector
 * to this adddess. 
 *
 * When we get here we are in x86 real mode.
 *
 *	%cs	= 0xf000	%ip	= 0x0000
 *	%ds	= 0x0000	%es	= 0x0000
 *	%dx	= 0x0yxx	(y = 3 for i386, 5 for pentium, 6 for P6,
 *					where x is undefined)
 *	%fl	= 0x0002
 */
 	.text
	.code16
/*
 	.org	0x1000		/* FIXME should not be hardcoded */
/* linuxbios won't use this crt0 file, since we grab bits of .S
 * files as part of startup.S
 * we do this to help out freebios, assuming they want to stick with it
 */
#include "intel_start32.S"

	/* initialize the RAM */
	/* I hate doing includes of code. Once
	 * we have a stack we don't need this, but just this once ...
	 */

#define INTEL_440RAM
#ifdef INTEL_440RAM
#include "intel_440ram.S"
#endif
/*
 *	Copy data into RAM and clear the BSS. Since these segments
 *	isn't really that big we just copy/clear using bytes, not
 *	double words.
 */
	intel_chip_post_macro(0x11)	/* post 11 */

	cld				/* clear direction flag */
	leal	EXT(_ldata), %esi
	leal	EXT(_data), %edi
	movl	$EXT(_eldata), %ecx
	subl	%esi, %ecx
	jz	.Lnodata		/* should not happen */
	rep
	movsb
.Lnodata:
	intel_chip_post_macro(0x12)	/* post 12 */
	
	/** clear stack */
	xorl	%edi, %edi
	movl	$_PDATABASE, %ecx
	xorl	%eax, %eax
	rep
	stosb
	/** clear bss */
	leal	EXT(_bss), %edi
	movl	$EXT(_ebss), %ecx
	subl	%edi, %ecx
	jz	.Lnobss
	xorl	%eax, %eax
	rep
	stosb
.Lnobss:
	
/*
 *	Initiailize the last things.
 */
	intel_chip_post_macro(0x13)	/* post 13 */

/*
	jmp	intel_panic
	call	EXT(intel_bootstrap)
 */

/*
 *	Turn the on the cache!
 *
 */
#if 0
 	movb	$0x20, %ah
	intel_conf_read_macro
	orb	$3, %al
	intel_conf_write_macro
#endif

/*
 *	Now we are finished. Memory is up, data is copied and
 *	bss is cleared.   Now we call the ``main routine and
 *	let it do the rest.
 */ 
	intel_chip_post_macro(0xfe)	/* post fe */

/* memory is up. Let's do the rest in C -- much easier. */
	call	EXT(intel_main)
	/*NOTREACHED*/
.Lhlt:	hlt
	jmp	.Lhlt


/*
 *	intel_panic:
 *
 *	A simple routine that beeps and halts the CPU. The number of times
 *	that the CPU should beep is specified in the %dx register.
 */
STATIC(intel_panic)
	movb	$0xb6, %al
	outb	%al, $0x43
	.word	0xe3
	movb	$5, %al
	outb	%al, $0x42
	.word	0xe3
	outb	%al, $0x42

.Lsoundon:
	movb	$0xf, %al
	outb	%al, $0x61

	movl	$0xC0000, %cx
0:	loop	0b

	movb	$0xc, %al
	outb	%al, $0x61

	movl	$0xC0000, %cx
0:	loop	0b

	dec	%dx
	jnz	.Lsoundon

0:	jmp	0b

/*
 *	A
 */
GLOBAL(intel_bell)
	movb	$0xb6, %al
	outb	%al, $0x43
	.word	0xe3
	movb	$5, %al
	outb	%al, $0x42
	.word	0xe3
	outb	%al, $0x42

.Lsoundon0:
	movb	$0xf, %al
	outb	%al, $0x61

	movl	$0xC0000, %cx
0:	loop	0b

	movb	$0xc, %al
	outb	%al, $0x61
	ret

/*
 *	This is private data to the startup code. This data
 *	is relocated at _PDATABASE and are copied there as fast
 *	as the memory is availible. This data is used to 
 *	get the system into 32-bit protected mode. IDT and other
 *	stuff is up to the 32-bit code to initialize.
 */
#if 0
	section .pdata, "aw"		/* ALLOC, DATA */
#endif
pdata_magic:
	.word	INTEL_PDATA_MAGIC
