#ifndef CONF_H
#define	CONF_H

/*
 * Bootstrap code for the STPC Consumer
 * Copyright (c) 1999 by Net Insight AB. All Rights Reserved.
 *
 * $Id: stpc_conf.h,v 1.2 2000/03/05 21:52:13 jgarzik Exp $
 *
 */

#include <rom/stpc.h>

/*
 * XXX comment here
 */
#undef	STPC_DRAM_AUTOSIZE

/*
 * The default memory type.
 */
#define	STPC_DRAM_TYPE		STPC_DRAM_EDO_60
#define	STPC_DRAM_EDO

/*
 * This enables if we are able to use 64-bit memory.
 * By default all memory is 32-bit.
 */
#define	STPC_DRAM_64BIT		

/* 
 * If we are not autosizing, we set the top of the memory 
 * banks here.
 *
 * How to calculate the top address of the banks:
 *
 *	topaddr = # of mb - 0x1
 *
 * If you have 8MB of memory in a bank, this will
 * result in (0x8 - 0x1) = 0x7. If this is all the
 * memory, set the other top addresses to the same
 * value.
 */
#define	STPC_DRAM_WIDTH_64	0
#define	STPC_DRAM_WIDTH_32	1
 
#ifndef	STPC_DRAM_AUTOSIZE
#define	STPC_MB0_TOPADDR	0x0f
#define	STPC_MB0_WIDTH		STPC_DRAM_WIDTH_64
#define	STPC_MB1_TOPADDR	0x1f
#define	STPC_MB1_WIDTH		STPC_DRAM_WIDTH_64
#define	STPC_MB2_TOPADDR	0x1f
#define	STPC_MB2_WIDTH		STPC_DRAM_WIDTH_64
#define	STPC_MB3_TOPADDR	0x1f
#define	STPC_MB3_WIDTH		STPC_DRAM_WIDTH_64
#define	STPC_MB_WIDTH		(STPC_MB3_WIDTH << 3 | STPC_MB2_WIDTH << 2 | STPC_MB1_WIDTH << 1 | STPC_MB0_WIDTH)
#endif

#define	STPC_FRAME_BUF_SZ	1024	/* will be divided with 128 */

#endif /* CONF_H */
