/*
 * Bootstrap code for the STPC Consumer
 * Copyright (c) 1999 by Net Insight AB. All Rights Reserved.
 *
 * $Id: host2pci.c,v 1.2 2000/03/05 21:52:13 jgarzik Exp $
 *
 */

#ifndef lint
static char rcsid[] = "$Id: host2pci.c,v 1.2 2000/03/05 21:52:13 jgarzik Exp $"; 
#endif

#include <rom/bus/bus.h>
#include <rom/bus/pci.h>
#include <rom/device.h>

/*
 *	This is a generic PCI device driver. It is used to configure
 *	unknown devices on the PCI bus. 
 */

/*
 *	PCI device private data:
 */
typedef struct host2pci_softc {
	bus_t		sc_bus;		/* our bus */
	pci_tag_t	sc_tag;		/* pci tag */
} *host2pci_softc_t;

/*
 *	Routine 0 when found, else !0
 */
int host2pciprobe(
	device_t	parent,
	cfdata_t	cf,
	void		*aux)
{
	pci_attach_args_t pa = (pci_attach_args_t) aux;

	if(pa->pa_bargs.ba_bus->bus_type != BUS_TYPE_PCI)
		return CF_MATCH_NONE;

	if(pa->pa_vendorid == 0x100e && pa->pa_productid == 0x564)
		return CF_MATCH_EXACT;
	return CF_MATCH_NONE;
}

/*
 *
 */
int32_t host2pciattach(
	device_t	parent,
	device_t	self,
	void		*aux)
{
	host2pci_softc_t sc = (host2pci_softc_t) self->dv_softc;
	pci_attach_args_t pa = (pci_attach_args_t) aux;
	bus_t		bus;
	
	/*
	 * Print some information about the device.
	 */	
	device_print(self, pa);	
	printf(": host-to-pci bridge\n");
	return 0;
}

/*
 *	Device configration data:
 */
struct cfattach ca_pci_host2pci = {
	sizeof(struct host2pci_softc),
	host2pciprobe,	/* match */
	host2pciattach,	/* attach */
	0,		/* detach */
	"host2pci"	/* name */
};
