/*
 * Bootstrap code for the STPC Consumer
 * Copyright (c) 1999 by Net Insight AB. All Rights Reserved.
 *
 * $Id: pci.c,v 1.2 2000/03/05 21:52:13 jgarzik Exp $
 *
 */

#ifndef lint
static char rcsid[] = "$Id: pci.c,v 1.2 2000/03/05 21:52:13 jgarzik Exp $"; 
#endif

#include <rom/bus/bus.h>
#include <rom/bus/pci.h>
#include <rom/device.h>

/*
 *	This is a generic PCI device driver. It is used to configure
 *	unknown devices on the PCI bus. 
 */

/** forward: */
extern struct device_ops do_pci_pci;

/*
 *	PCI device private data:
 */
typedef struct pci_softc {
	bus_t			sc_bus;		/* our bus */
	pci_tag_t		sc_tag;		/* pci tag */
} *pci_softc_t;

/*
 *	Routine 0 when found, else !0
 */
int pciprobe(
	device_t	parent,
	cfdata_t	cf,
	void		*aux)
{
	bus_attach_args_t ba = (bus_attach_args_t) aux;

	if(ba->ba_bus->bus_type != BUS_TYPE_PCI)
		return CF_MATCH_NONE;
	return CF_MATCH_LOW;
}

/*
 *
 */
int32_t pciattach(
	device_t	parent,
	device_t	self,
	void		*aux)
{
	pci_softc_t	sc = (pci_softc_t) self->dv_softc;
	pci_attach_args_t pa = (pci_attach_args_t) aux;
	bus_t		bus;

	/*
	 * Print some information about the device.
	 */	
	device_print(self, pa);	
	printf(": vendor: %#x product: %#x class: %#x subclass: %#x\n", 
		pa->pa_vendorid,
		pa->pa_productid,
		pa->pa_class,
		pa->pa_subclass);
	return 0;
}

/*
 *	Device configration data:
 */
struct cfattach ca_pci_pci = {
	sizeof(struct pci_softc),
	pciprobe,	/* match */
	pciattach,	/* attach */
	0,		/* detach */
	"pci"		/* name */
};
