#ifndef DEVICE_PCI2IDE_H
#define DEVICE_PCI2IDE_H

/*
 * Bootstrap code for the STPC Consumer
 * Copyright (c) 1999 by Net Insight AB. All Rights Reserved.
 *
 * $Id: pciide.h,v 1.2 2000/03/05 21:52:13 jgarzik Exp $
 *
 */

#include <rom/bus/bus.h>
#include <rom/bus/isa.h>

/*
 *	Configuration here:
 */
#define	NCHANNELS				2
#define	NDRIVES					2

/*
 * 	Definitions for the southbridge:
 */
#define	SB_INTERFACE_SECONDARY_MODE_NATIVE	0x04
#define	SB_INTERFACE_SECONDARY_MODE_LEGACY	0x00
#define	SB_INTERFACE_PRIMARY_MODE_NATIVE	0x01
#define	SB_INTERFACE_PRIMARY_MODE_LEGACY	0x00

#define	PCIIDE_IOBASE_PRIMARY			0x1f0
#define	PCIIDE_IOBASE_PRIMARY_AUX		0x3f6
#define	PCIIDE_IOBASE_SECONDARY			0x170
#define	PCIIDE_IOBASE_SECONDARY_AUX		0x376

#define PCIIDE_CHANSTATUS_EN			0x40
#define PCIIDE_CHAN_EN(chan)			(0x20 >> (chan))
#define PCIIDE_INTERFACE_PCI(chan)		(0x01 << (2 * (chan)))
#define PCIIDE_INTERFACE_SETTABLE(chan)		(0x02 << (2 * (chan)))
#define PCIIDE_INTERFACE_BUS_MASTER_DMA		0x80

#define	PCIIDE_CHAN_NAME(chan)			(chan ? "secondary" : "primary")
#define	PCIIDE_CHAN_IOBASE_CMD(chan)		(chan ? PCIIDE_IOBASE_SECONDARY : PCIIDE_IOBASE_PRIMARY)
#define	PCIIDE_CHAN_IOBASE_AUX(chan)		(chan ? PCIIDE_IOBASE_SECONDARY_AUX : PCIIDE_IOBASE_PRIMARY_AUX)

/*
 *	PCI IDE attach arguments:
 *
 *	the pciide bus is a pseudo bus. devices (harddisk controles)
 *	attach to the bus is using the ISA bus for communication.
 */
typedef struct pciide_attach_args {
	struct bus_attach_args	pi_bargs;	/* bus arguments */

	isa_tag_t		pi_cmdtag;	/* cmd tag */
	isa_tag_t		pi_auxtag;	/* clt tag */
	
	unsigned int		pi_channel;	/* channel we are connected to */
	unsigned int		pi_drive;	/* drive */
} *pciide_attach_args_t;

#endif /* DEVICE_PCI2IDE_H */
