/*
 * Bootstrap code for the STPC Consumer
 * Copyright (c) 1999 by Net Insight AB. All Rights Reserved.
 *
 * $Id: twintin.c,v 1.2 2000/03/05 21:52:13 jgarzik Exp $
 *
 */

#ifndef lint
static char rcsid[] = "$Id: twintin.c,v 1.2 2000/03/05 21:52:13 jgarzik Exp $"; 
#endif

#include <rom/bus/bus.h>
#include <rom/bus/pci.h>
#include <rom/device.h>

/*
 *	This is a generic PCI device driver. It is used to configure
 *	unknown devices on the PCI bus. 
 */

/** forward: */
extern struct device_ops do_pci_twintin;

/*
 *	PCI device private data:
 */
typedef struct twintin_softc {
	bus_t			sc_bus;		/* our bus */
	bus_space_tag_t		sc_iot;		/* our I/O tag */
	bus_space_handle_t	sc_ioh;		/* our I/O handle */

	bus_space_tag_t		sc_devt;	/* our device tag */
	bus_space_handle_t	sc_devh;	/* our device handle */
} *twintin_softc_t;

/*
 *	Routine 0 when found, else !0
 */
int twintinprobe(
	device_t	parent,
	cfdata_t	cf,
	void		*aux)
{
	pci_attach_args_t pa = (pci_attach_args_t) aux;

	if(pa->pa_bargs.ba_bus->bus_type != BUS_TYPE_PCI)
		return CF_MATCH_NONE;

	if(pa->pa_vendorid == 0x1477) 
		return CF_MATCH_EXACT;
	return CF_MATCH_NONE;
}

/*
 *
 */
int32_t twintinattach(
	device_t	parent,
	device_t	self,
	void		*aux)
{
	twintin_softc_t	sc = (twintin_softc_t) self->dv_softc;
	pci_attach_args_t pa = (pci_attach_args_t) aux;
	unsigned	div, iobase;
	bus_t		bus;
	
	/*
	 * Print some information about the device.
	 */	
	device_print(self, pa);	
	printf(": product: %#x class: %#x subclass: %#x\n", 
		pa->pa_productid,
		pa->pa_class,
		pa->pa_subclass);
	return 0;
}

/*
 *	Device configration data:
 */
struct cfattach ca_pci_twintin = {
	sizeof(struct twintin_softc),
	twintinprobe,	/* match */
	twintinattach,	/* attach */
	0,		/* detach */
	"twintin"	/* name */
};
