#ifndef ROM_BUS_ISA_H
#define	ROM_BUS_ISA_H

/*
 * Bootstrap code for the STPC Consumer
 * Copyright (c) 1999 by Net Insight AB. All Rights Reserved.
 *
 * $Id: isa.h,v 1.2 2000/03/05 21:52:13 jgarzik Exp $
 *
 */

#include <sys/cdefs.h>
#include <sys/types.h>

#include <rom/bus/bus.h>

/*
 *	Special configuration for ISA devices.
 */
typedef struct isa_cfdata_args {
	long	ca_iobase;	/* i/o base */
	long	ca_irq;		/* irq */
} isa_cfdata_args;

/*
 *	Arguments sent to a ISA device when probing.
 */
typedef struct isa_attach_args {
	struct bus_attach_args	ia_bargs;	/* bus args */
	bus_t			ia_bus;		/* the ISA bus */
	isa_cfdata_args	*	ia_cfargs;	/* cfargs */
} isa_attach_args;

/*
 *	isa_tag_t is used to access the ISA bus.
 */
typedef u_int16_t isa_tag_t;

/*
 *	Prototypes:
 */
extern void isa_interrupt_enable __P((
		int));			/* interrupt number */

extern void isa_interrupt_establish __P((
		int,			/* interrupt number */
		void *,			/* routine */
		void *));		/* aux */

extern isa_tag_t isa_maketag __P((
		u_int16_t));		/* I/O base */

extern void isa_write_4 __P((
		isa_tag_t,		/* tag */
		u_int16_t,		/* register */
		u_int32_t));		/* value */

extern void isa_write_2 __P((
		isa_tag_t,		/* tag */
		u_int16_t,		/* register */
		u_int16_t));		/* value */

extern void isa_write_1 __P((
		isa_tag_t,		/* tag */
		u_int16_t,		/* register */
		u_int8_t));		/* value */

extern u_int32_t isa_read_4 __P((
		isa_tag_t,		/* tag */
		u_int16_t));		/* register */

extern u_int16_t isa_read_2 __P((
		isa_tag_t,		/* tag */
		u_int16_t));		/* register */

extern u_int8_t isa_read_1 __P((
		isa_tag_t,		/* tag */
		u_int16_t));		/* register */

extern void isa_read_2s __P((
		isa_tag_t,		/* tag */
		u_int16_t,		/* register */
		char *,			/* buffer */
		int));			/* length */

#endif /* ROM_BUS_ISA_H */
