#ifndef ROM_FILE_H
#define	ROM_FILE_H

/*
 * Bootstrap code for the STPC Consumer
 * Copyright (c) 1999 by Net Insight AB. All Rights Reserved.
 *
 * $Id: file.h,v 1.2 2000/03/05 21:52:13 jgarzik Exp $
 *
 */

#include <sys/cdefs.h>
#include <sys/types.h>

#include <rom/device.h>
#include <rom/fs.h>

/*
 *	File structure for standard I/O:
 */
typedef struct file {
	device_unit_t	f_unit;		/* device this file belongs to */
	unsigned int	f_mode;		/* mode */
	u_int32_t	f_offset;	/* offset in file */
	filesystem_t	f_fs;		/* filesystem */
	void *		f_aux;		/* private data */
} *file_t;
#define	FILE_NULL	((file_t) 0)

#endif /* ROM_FILE_H */
