#ifndef ROM_STPC_H
#define	ROM_STPC_H

/*
 * Bootstrap code for the STPC Consumer
 * Copyright (c) 1999 by Net Insight AB. All Rights Reserved.
 *
 * $Id: stpc.h,v 1.2 2000/03/05 21:52:13 jgarzik Exp $
 *
 */

/* 
 *	SIP configration registers:
 */
#define	STPC_CONF_REG_INDEX	0x22
#define	STPC_CONF_REG_DATA	0x23

/* 
 *	DRAM types:
 */
#define	STPC_DRAM_FPM_60	0
#define	STPC_DRAM_FPM_70	1
#define	STPC_DRAM_EDO_60	2
#define	STPC_DRAM_EDO_70	3

/*
 *	Macro:		stpc_conf_write_macro
 *	Prototype:	value = stpc_conf_write_macro(reg, data)
 *			 %al                          %ah   %al
 */
#define	stpc_conf_write_macro				\
	xchgb	%ah, %al				;\
	outb	%al, $STPC_CONF_REG_INDEX		;\
	xchgb	%ah, %al				;\
	outb	%al, $STPC_CONF_REG_DATA

/* 
 *	Macro:		stpc_conf_read_macro
 *	Prototype:	value = stpc_conf_write_read(reg)
 *			 %al                         %ah
 */
#define	stpc_conf_read_macro				\
	xchgb	%ah, %al				;\
	outb	%al, $STPC_CONF_REG_INDEX		;\
	xchgb	%ah, %al				;\
	inb	$STPC_CONF_REG_DATA, %al

/*
 *	Macro:		stpc_chip_getbusspeed_macro
 *	Prototype:	value = stpc_chip_getbusspeed()
 *			 %al
 *	Trashed:	%ah, %al
 */
#define	stpc_chip_getbusspeed_macro			\
	movb	$0x5f, %ah				;\
	stpc_conf_read_macro				;\
	andb	$0b00111000, %al			;\
	shrb	$3, %al

/*
 *	Macro:	stpc_chip_post_macro
 *	Prototype:	stpc_chip_post(value)
 *	Trashed:	%al
 */
#define	stpc_chip_post_macro(value)			\
	movb	$(value), %al				;\
	outb	%al, $0x80

#endif /* ROM_STPC_H */
