/*
 * Bootstrap code for the STPC Consumer
 * Copyright (c) 1999 by Net Insight AB. All Rights Reserved.
 *
 * $Id: boot_conf.c,v 1.2 2000/03/05 21:52:13 jgarzik Exp $
 *
 */

#ifndef lint
static char rcsid[] = "$Id: boot_conf.c,v 1.2 2000/03/05 21:52:13 jgarzik Exp $"; 
#endif

#include <rom/device.h>
#include <rom/bus/isa.h>

#include <rom/fs.h>
#include <rom/file.h>

/** buses: */
extern struct cfattach ca_isabus;
extern struct cfattach ca_pcibus;
extern struct cfattach ca_main;

/** pci devices: */
extern struct cfattach ca_pci_pci;
extern struct cfattach ca_pci_pciisa;
extern struct cfattach ca_pci_pciide;
extern struct cfattach ca_pci_host2pci;
extern struct cfattach ca_pci_twintin;

extern struct cfattach ca_pciide_wd;

/** isa devices: */
extern struct cfattach ca_isa_ide;

/*
 *	Drivers:
 */
struct cfdriver cd_main
	= {	0	};
 
struct cfdriver cd_isabus
	= {	0	};
struct cfdriver cd_isa_ide
	= {	0	};

struct cfdriver cd_pcibus 
	= {	0	};
struct cfdriver cd_pci_pci
	= {	0	};
struct cfdriver cd_pci_pciisa
	= {	0	};
struct cfdriver cd_pci_pciide
	= {	0	};
struct cfdriver cd_pci_host2pci
	= {	0	};
struct cfdriver cd_pci_twintin
	= {	0	};

struct cfdriver cd_pciide_wd
	= {	0	};

#define	STAR	-1

#define	BMAIN	0
#define	BPCI	1
#define	BISA	3
#define	BPCIIDE	6	/* a brideg */

/*
 *	The table of devices and buses that the "auto" configure routines
 *	should install. Buses are devices without parents.
 */
struct cfdata device_cfdev[] = {
	/** main bus: */
	{ &ca_main,		&cd_main,		0,	0,		0,	0			},	/* mainbus0		*/

	/** pci buses: */
	{ &ca_pcibus,		&cd_pcibus,		0,	0,		0,	&device_cfdev[BMAIN]	},	/* pcibus0 on mainbus0	*/
	{ &ca_pcibus,		&cd_pcibus,		STAR,	0,		0,	&device_cfdev[BPCI]	},	/* pcibus* on pcibus	*/

	/** isa bus: */
	{ &ca_isabus,		&cd_isabus,		0,	0,		0,	&device_cfdev[BMAIN]	},	/* isabus0 on mainbus0	*/

	/** pci devices: */
	{ &ca_pci_pci,		&cd_pci_pci,		STAR,	0,		0,	&device_cfdev[BPCI]	},	/* pci* on pcibus*	*/

	/** pci bridges: */
	{ &ca_pci_pciisa,	&cd_pci_pciisa,		STAR,	0,		0,	&device_cfdev[BPCI]	},	/* pciisa* on pcibus*	*/
	{ &ca_pci_pciide,	&cd_pci_pciide,		STAR,	0,		0,	&device_cfdev[BPCI]	},	/* pciide* on pcibus*	*/
	{ &ca_pci_host2pci,	&cd_pci_host2pci,	0,	0,		0,	&device_cfdev[BPCI]	},	/* host2pci0 on pcibus* */

	/** twintin": */
	{ &ca_pci_twintin,	&cd_pci_twintin,	STAR,	0,		0,	&device_cfdev[BPCI]	},	/* twintin* on pcibus*	*/

#if 0
	/** harddisks: */
	{ &ca_isa_ide,		&cd_isa_ide,		0,	0,		0,	&device_cfdev[BISA]	},	/* ide0 on isabus0	*/
#if 0
	{ &ca_isa_ide,		&cd_isa_ide,		1,	0,		0,	&device_cfdev[BISA]	},	/* ide0 on isabus1	*/
#endif
#endif

#if 1
	/** geeh: */
	{ &ca_pciide_wd,	&cd_pciide_wd,		STAR,	0,		0,	&device_cfdev[6]	},	/* wd* on pciide*	*/
#endif

	{ 0,			0,			0,	0,		0,	0			}	/* EOT			*/
};
