/*
 * Bootstrap code for the STPC Consumer
 * Copyright (c) 1999 by Net Insight AB. All Rights Reserved.
 *
 * $Id: bus_isa.c,v 1.2 2000/03/05 21:52:13 jgarzik Exp $
 *
 */

#ifndef lint
static char rcsid[] = "$Id: bus_isa.c,v 1.2 2000/03/05 21:52:13 jgarzik Exp $"; 
#endif

#include <rom/device.h>
#include <rom/bus/bus.h>
#include <rom/bus/isa.h>

/*
 *
 */
typedef struct isa_softc {
	int	a, b, c;
} *isa_softc_t;

/*
 *
 */
static bus_t isa_bus;

/*
 *
 */
int isasubmatch(
	device_t	parent,
	struct cfdata	*cf,
	void		*aux)
{
	struct isa_attach_args *ia = (struct isa_attach_args *) aux;

	/*
	 *	Initialize the arguments.
	 */
	ia->ia_cfargs	= (isa_cfdata_args *) cf->cf_data;
	return (*cf->cf_attach->ca_match)(parent, cf, (void *) ia);
}

/*
 *
 */
int isamatch(
	device_t	parent,
	cfdata_t	cf,
	void		*aux)
{
	unsigned char a;

	/*
	 * A test!
	 */
	return CF_MATCH_EXACT;
}

/*
 *	Attach for the ISA bus.
 */
int32_t isaattach(
	device_t	parent,
	device_t	self,
	void		*aux)
{
	struct isa_attach_args ia;
	int ret = 0;

	/*
	 * XXX bus creation.
	 */
	isa_bus = (bus_t) bus_create(self,
					BUS_TYPE_ISA,
					0,		/* fixed unit */
					0,
					0);
	ia.ia_bargs.ba_bus	= isa_bus;

	/*
	 * XXX information to user
	 */
	device_print(self, aux);
	printf("\n");

	/*
	 * Configure all devices on the ISA bus.
	 */
	ret = config_search(self,	/* isabus */
			isasubmatch,	/* routine */
			&ia);		/* aux */
	return 0;
}

/*
 *	Configuration data for the ISA bus.
 */
struct cfattach ca_isabus = {
	sizeof(struct isa_softc), 	/* sizeof device private data */
	isamatch,			/* isa match routine */
	isaattach,			/* isa attach routine */
	0,				/* isa detach routine */
	"isabus"			/* name of "device" */
};
