/*
 * Bootstrap code for the STPC Consumer
 * Copyright (c) 1999 by Net Insight AB. All Rights Reserved.
 *
 * $Id: bus_main.c,v 1.2 2000/03/05 21:52:13 jgarzik Exp $
 *
 */

#ifndef lint
static char rcsid[] = "$Id: bus_main.c,v 1.2 2000/03/05 21:52:13 jgarzik Exp $"; 
#endif

#include <rom/device.h>
#include <rom/bus/bus.h>

/*
 *
 */
typedef struct main_softc {
	int	a, b, c;
} *main_softc_t;

/*
 *	mainbus bus structure:
 */
static bus_t main_bus;

/*
 *
 */
int mainsubmatch(
	device_t	parent,
	struct cfdata	*cf,
	void		*aux)
{
	struct bus_attach_args *ba = (struct bus_attach_args *) aux;
	ba->ba_unit	= cf->cf_unit;

	return (*cf->cf_attach->ca_match)(parent, cf, aux);
}

/*
 *
 */
int mainmatch(
	device_t	parent,
	cfdata_t	cf,
	void		*aux)
{
	return 0;
}

/*
 *	Attach for the ISA bus.
 */
int32_t mainattach(
	device_t	parent,
	device_t	self,
	void		*aux)
{
	int ret = 0;

	struct bus_attach_args newba, *ba
		= (struct bus_attach_args *) aux;

	/*
	 * Create the bus. 
	 */
	main_bus = (bus_t) bus_create(self,
					BUS_TYPE_ISA,
					ba->ba_unit,
					0,
					0);
	newba.ba_bus	= main_bus;

	/*
	 * Configure all devices on the ISA bus.
	 */
	while(ret == 0) {
		ret = config_search(self,	/* isabus */
				mainsubmatch,	/* routine */
				&newba);	/* aux */
	}
}

/*
 *	Configuration data for the ISA bus.
 */
struct cfattach ca_main = {
	sizeof(struct main_softc), 	/* sizeof device private data */
	mainmatch,			/* main match routine */
	mainattach,			/* main attach routine */
	0,				/* main detach routine */
	"mainbus"			/* name of "device" */
};
