/*
 *
 */
 
#include <sys/cdefs.h> 
#include <rom/bus/bus.h>
#include <rom/bus/pci.h>
#include <rom/device.h>

#if 0
#define	DEBUG
#endif

/*
 *	Prototypes:
 */
extern pci_tag_t pci_maketag __P((
			unsigned char	bus,
			unsigned char	device,
			unsigned char	function));


/*
 *
 */
bus_t bus_create(
	device_t	device,
	bus_type	type,
	u_int32_t	number,
	u_int32_t	base,
	u_int32_t	limit)
{
	bus_t bus;
	
	if((bus = (bus_t) malloc(sizeof *bus)) == BUS_NULL)
		return BUS_NULL;
	
	queue_init(&bus->bus_space);

	/*
	 * Fill the new bus structure with information:
	 */
	bus->bus_device		= device;
	bus->bus_type		= type;
	bus->bus_number		= number;
	bus->bus_addr_base	= 0x0;
	bus->bus_addr_limit	= 0x0;
	return bus;
}
