/*
 * Bootstrap code for the STPC Consumer
 * Copyright (c) 1999 by Net Insight AB. All Rights Reserved.
 *
 * $Id: subr_device.c,v 1.2 2000/03/05 21:52:13 jgarzik Exp $
 *
 */

#ifndef lint
static char rcsid[] = "$Id: subr_device.c,v 1.2 2000/03/05 21:52:13 jgarzik Exp $"; 
#endif

#include <rom/device.h>
#include <rom/queue.h>
#include <rom/bus/bus.h>

/** from subr_autoconf.c: */
extern queue_head_t alldevs;

/*
 *
 */
void device_print(
	device_t		self,
	struct bus_attach_args	*ba)
{
	printf("%s on %s", self->dv_name, 
		ba->ba_bus->bus_device->dv_name);
}

/*
 *
 */
device_unit_t
device_open(
	char		*name,
	int		unit)
{
	device_t device = (device_t) queue_first(&alldevs);
	device_unit_t du;
	
	while(!queue_end(&alldevs, &device->dv_link)) {
		if(strcmp(name, device->dv_name) == 0) {
			du = (device_unit_t) malloc(sizeof *du);
			if(du == DEVICE_UNIT_NULL)
				return du;

			du->du_device	= device;
			du->du_unit	= unit;
			du->du_offset	= 0;
			
			return (*device->dv_ops->open)(du);
		}
		device = (device_t) queue_next(&device->dv_link);
	}
	return DEVICE_UNIT_NULL;
}

/*
 *
 */
void
device_close(
	device_unit_t	device)
{
	(*device->du_device->dv_ops->close)(device);
}

/*
 *
 */
int
device_read(
	device_unit_t	device,
	char		*buff,
	int		length)
{
	return (*device->du_device->dv_ops->read)(device, buff, length);
}

/*
 *
 */
int
device_write(
	device_unit_t	device,
	char		*buff,
	int		length)
{
	return (*device->du_device->dv_ops->write)(device, buff, length);
}

/*
 *
 */
int device_blk_read(
	device_unit_t	device,
	u_int32_t	sector,
	u_int32_t	sectors,
	char		*buffer)
{
	return wdc_blk_read(device, sector, sectors, buffer);
}
