/*
 * Bootstrap code for the STPC Consumer
 * Copyright (c) 1999 by Net Insight AB. All Rights Reserved.
 *
 * $Id: subr_isa.c,v 1.2 2000/03/05 21:52:13 jgarzik Exp $
 *
 */

#ifndef lint
static char rcsid[] = "$Id: subr_isa.c,v 1.2 2000/03/05 21:52:13 jgarzik Exp $"; 
#endif

#include <rom/bus/isa.h>

/*
 *
 */
isa_tag_t isa_maketag(
	u_int16_t	io)
{
	return (isa_tag_t) io;
}

/*
 *
 */
void isa_write_4(
	isa_tag_t	tag,		/* isa tag */
	u_int16_t	offset,		/* offset */
	u_int32_t	value)		/* value */
{
	outl((u_int16_t) tag + offset, value);
}

void isa_write_2(
	isa_tag_t	tag,		/* isa tag */
	u_int16_t	offset,		/* offset */
	u_int16_t	value)		/* value */
{
	outw((u_int16_t) tag + offset, value);
}

void isa_write_1(
	isa_tag_t	tag,		/* isa tag */
	u_int16_t	offset,		/* offset */
	u_int8_t	value)		/* value */
{
	outb((u_int16_t) tag + offset, value);
}

u_int32_t isa_read_4(
	isa_tag_t	tag,		/* isa tag */
	u_int16_t	offset)		/* offset */
{
	return inl((u_int16_t)tag + offset);
}

u_int16_t isa_read_2(
	isa_tag_t	tag,		/* isa tag */
	u_int16_t	offset)		/* offset */
{
	return inw((u_int16_t)tag + offset);
}

u_int8_t isa_read_1(
	isa_tag_t	tag,		/* isa tag */
	u_int16_t	offset)		/* offset */
{
	return inb((u_int16_t)tag + offset);
}

void isa_read_multi_1(
	isa_tag_t	tag,		/* isa tag */
	u_int16_t	offset,		/* offset */
	u_int8_t	*buffer,	/* buffet */
	int		length)		/* length */
{
	insb((u_int16_t)tag + offset, buffer, length);
}

void isa_read_multi_2(
	isa_tag_t	tag,		/* isa tag */
	u_int16_t	offset,		/* offset */
	u_int16_t	*buffer,	/* buffet */
	int		length)		/* length */
{
	insw((u_int16_t)tag + offset, buffer, length);
}

void isa_read_multi_4(
	isa_tag_t	tag,		/* isa tag */
	u_int16_t	offset,		/* offset */
	u_int32_t	*buffer,	/* buffet */
	int		length)		/* length */
{
	insl((u_int16_t)tag + offset, buffer, length);
}

void isa_write_multi_1(
	isa_tag_t	tag,		/* isa tag */
	u_int16_t	offset,		/* offset */
	u_int8_t	*buffer,	/* buffet */
	int		length)		/* length */
{
	outsb((u_int16_t)tag + offset, buffer, length);
}

void isa_write_multi_2(
	isa_tag_t	tag,		/* isa tag */
	u_int16_t	offset,		/* offset */
	u_int16_t	*buffer,	/* buffet */
	int		length)		/* length */
{
	outsw((u_int16_t)tag + offset, buffer, length);
}

void isa_write_multi_4(
	isa_tag_t	tag,		/* isa tag */
	u_int16_t	offset,		/* offset */
	u_int32_t	*buffer,	/* buffet */
	int		length)		/* length */
{
	outsl((u_int16_t)tag + offset, buffer, length);
}

