/*
 * Bootstrap code for the STPC Consumer
 * Copyright (c) 1999 by Net Insight AB. All Rights Reserved.
 *
 * $Id: subr_locore.S,v 1.2 2000/03/05 21:52:13 jgarzik Exp $
 *
 */

#include <rom/asm.h>

	.text
/*
 * outb, outw, outl;
 *
 *	Write to I/O port.
 */
ENTRY(outb)
	movl	4(%esp), %edx
	movl	8(%esp), %eax
	outb	%al, %dx
	ret
ENTRY(outw)
	movl	4(%esp), %edx
	movl	8(%esp), %eax
	outw	%ax, %dx
	ret
ENTRY(outl)
	movl	4(%esp), %edx
	movl	8(%esp), %eax
	outl	%eax, %dx
	ret

/*
 * inb, inw, inl:
 *
 *	Read from I/O port.
 */
ENTRY(inb)
	xorl	%eax, %eax
	movl	4(%esp), %edx
	inb	%dx, %al
	ret
ENTRY(inw)
	xorl	%eax, %eax
	movl	4(%esp), %edx
	inw	%dx, %ax
	ret
ENTRY(inl)
	xorl	%eax, %eax
	movl	4(%esp), %edx
	inl	%dx, %eax
	ret

/*
 *
 */
ENTRY(insb)
	movl	4(%esp), %edx
	movl	8(%esp), %edi
	movl	12(%esp), %ecx
	rep
	insb
	ret

ENTRY(insw)
	movl	4(%esp), %edx
	movl	8(%esp), %edi
	movl	12(%esp), %ecx
	rep
	insw
	ret

ENTRY(insl)
	movl	4(%esp), %edx
	movl	8(%esp), %edi
	movl	12(%esp), %ecx
	rep
	insl
	ret

ENTRY(outsb)
	movl	4(%esp), %edx
	movl	8(%esp), %esi
	movl	12(%esp), %ecx
	rep
	outsb
	ret

ENTRY(outsw)
	movl	4(%esp), %edx
	movl	8(%esp), %esi
	movl	12(%esp), %ecx
	rep
	outsw
	ret

ENTRY(outsl)
	movl	4(%esp), %edx
	movl	8(%esp), %esi
	movl	12(%esp), %ecx
	rep
	outsl
	ret

/*
 *	bcopy(src, dst, length):
 */
ENTRY(bcopy)
	movl	4(%esp), %esi
	movl	8(%esp), %edi
	movl	12(%esp), %ecx
	rep
	movsb	%ds:(%esi), %ds:(%edi)
	ret

/*
 *
 */
ENTRY(timer_delay)
	movl	4(%esp), %ecx
	shl	$8, %ecx
0:	
	loop	0b
	ret

/*
 * Ported to boot 386BSD by Julian Elischer (julian@tfs.com) Sept 1992
 *
 * Mach Operating System
 * Copyright (c) 1992, 1991 Carnegie Mellon University
 * All Rights Reserved.
 * 
 * Permission to use, copy, modify and distribute this software and its
 * documentation is hereby granted, provided that both the copyright
 * notice and this permission notice appear in all copies of the
 * software, derivative works or modified versions, and any portions
 * thereof, and that both notices appear in supporting documentation.
 * 
 * CARNEGIE MELLON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS"
 * CONDITION.  CARNEGIE MELLON DISCLAIMS ANY LIABILITY OF ANY KIND FOR
 * ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 * 
 * Carnegie Mellon requests users of this software to return to
 * 
 *  Software Distribution Coordinator  or  Software.Distribution@CS.CMU.EDU
 *  School of Computer Science
 *  Carnegie Mellon University
 *  Pittsburgh PA 15213-3890
 * 
 * any improvements or extensions that they make and grant Carnegie Mellon
 * the rights to redistribute these changes.
 */

/*
 * startkernel(phyaddr,argc,argv,stack)
 *	start the program on protected mode where phyaddr is the entry point
 */
ENTRY(startkernel)
	pushl	%ebp
	movl	%esp, %ebp

	/* prepare a new stack */
	movl	$0x10, %ebx
	movw	%bx, %es	/* for arg copy */
	movl	20(%ebp), %eax	/* stack */
	subl	$4,%eax
	movl	%eax, %edi
	
	/* push some number of args onto the stack */
	movl	12(%ebp), %ecx		/* argc */

	movl	%ecx, %eax
	decl	%eax
	shl	$2, %eax
	addl	16(%ebp), %eax	/* ptr to last arg */
	movl	%eax, %esi

	std			/* backwards */
	rep
	movsl

	movl	8(%ebp), %ecx	/* entry */

	/* set new stackptr (movsl decd sp 1 more -> dummy return address) */
	movw	%bx, %ss
	movl	%edi, %esp
	subl	$4, %esp

	/* XX */
	jmp	*%ecx

